Subject: Re: [PATCH v3 net-next 18/24] net: dsa: sja1105: Add support for traffic through standalone ports

From: Andrew Lunn <[email-masked]>
Date: Sun, 14 Apr 2019 21:06:37 +0200

> Yes, it looks like the hardware isn't doing me any favors on this one.
> >From UM10944: "If the host provides several management route entries
> with identical values for the MACADDR, the one at the lowest index is
> used first."
> So the 4 hardware management slots serve no purpose unless I'm willing
> to lock the sja1105_xmit_work_handler with a mutex. And even then
> there's no reason to use separate slots since the workers are
> serialized anyway. Weird.

So you can simply this down to just using one queue. Maybe even one
queue for all instances of this switch. You can then keep it all as
static private structures in the tag driver, maybe not even needing
ds->tag_priv.

> > Also, DSA has been very successful, we keep getting more switches from
> > different vendors, and hence more taggers. So at some point, we should
> > turn the taggers into modules. I'm not saying that should happen now,
> > but when it does happen, this driver can then become a module.

FYI: I started on this already. There might be patches today to allow
the tag drivers to be kernel modules.

    Andrew